Program TriDpohyb;
uses Crt,
     SchGraph;

Type Bodtype=record
              x,y,z:integer;
             end;
Type CubeType=record
               bod:array[1..8,1..3] of longint;
               cia:array[1..12,1..2] of byte;
               plo:array[1..6,1..4] of byte;
              end;

var
 ctab:array[0..255] of integer;
 stab:array[0..255] of integer;
 koc:cubetype;

function cosinus(i:byte):integer; begin cosinus:=ctab[i]; end;
function sinus(i:byte):integer; begin sinus:=stab[i]; end;

Procedure InitAnim;
var i:integer;
begin
 InitGr;
 for i:=0 to 255 do ctab[i]:=round(-cos(i*pi/128)*divd);
 for i:=0 to 255 do stab[i]:=round(sin(i*pi/128)*divd);

 koc.bod[1][1]:=-30; koc.bod[1][2]:=-30; koc.bod[1][3]:=-30;
 koc.bod[2][1]:=30; koc.bod[2][2]:=-30; koc.bod[2][3]:=-30;
 koc.bod[3][1]:=30; koc.bod[3][2]:=30; koc.bod[3][3]:=-30;
 koc.bod[4][1]:=-30; koc.bod[4][2]:=30; koc.bod[4][3]:=-30;
 koc.bod[5][1]:=-30; koc.bod[5][2]:=-30; koc.bod[5][3]:=30;
 koc.bod[6][1]:=30; koc.bod[6][2]:=-30; koc.bod[6][3]:=30;
 koc.bod[7][1]:=30; koc.bod[7][2]:=30; koc.bod[7][3]:=30;
 koc.bod[8][1]:=-30; koc.bod[8][2]:=30; koc.bod[8][3]:=30;

 koc.cia[1][1]:=1;koc.cia[1][2]:=2;
 koc.cia[2][1]:=2;koc.cia[2][2]:=3;
 koc.cia[3][1]:=3;koc.cia[3][2]:=4;
 koc.cia[4][1]:=4;koc.cia[4][2]:=1;
 koc.cia[5][1]:=5;koc.cia[5][2]:=6;
 koc.cia[6][1]:=6;koc.cia[6][2]:=7;
 koc.cia[7][1]:=7;koc.cia[7][2]:=8;
 koc.cia[8][1]:=8;koc.cia[8][2]:=5;
 koc.cia[9][1]:=1;koc.cia[9][2]:=5;
 koc.cia[10][1]:=2;koc.cia[10][2]:=6;
 koc.cia[11][1]:=3;koc.cia[11][2]:=7;
 koc.cia[12][1]:=4;koc.cia[12][2]:=8;

 koc.plo[1][1]:=1;koc.plo[1][2]:=2;koc.plo[1][3]:=3;koc.plo[1][4]:=4;
 koc.plo[2][1]:=5;koc.plo[2][2]:=6;koc.plo[2][3]:=7;koc.plo[2][4]:=8;
 koc.plo[3][1]:=1;koc.plo[3][2]:=5;koc.plo[3][3]:=6;koc.plo[3][4]:=2;
 koc.plo[4][1]:=2;koc.plo[4][2]:=6;koc.plo[4][3]:=7;koc.plo[4][4]:=3;
 koc.plo[5][1]:=4;koc.plo[5][2]:=8;koc.plo[5][3]:=7;koc.plo[5][4]:=3;
 koc.plo[6][1]:=1;koc.plo[6][2]:=5;koc.plo[6][3]:=8;koc.plo[6][4]:=4;

end;

Procedure DrawCube;
begin
end;

Procedure Kresli;
var n,i,j,k,x,y:longint;
    phix,phiy,phiz:byte;
    uhx,uhy,uhz:integer;
    xp,yp,z:array[1..8] of integer;
begin
 uhx:=0;
 uhy:=1;
 uhz:=0;
 phix:=0;phiy:=0;phiz:=0;
 repeat

    setcol(15);
    for n:=1 to 8 do begin
      i:=(cosinus(phiy)*koc.bod[n,1]-sinus(phiy)*koc.bod[n,3]) div divd;
      j:=(cosinus(phiz)*koc.bod[n,2]-sinus(phiz)*i) div divd;
      k:=(cosinus(phiy)*koc.bod[n,3]+sinus(phiy)*koc.bod[n,1]) div divd;
      x:=(cosinus(phiz)*i+sinus(phiz)*koc.bod[n,2]) div divd;
      y:=(cosinus(phix)*j+sinus(phix)*k) div divd;
      z[n]:=(cosinus(phix)*k-sinus(phix)*j) div divd;
      xp[n]:=320+(-x*dist) div (z[n]-dist);
      yp[n]:=240+(-y*dist) div (z[n]-dist);
    end;

{  for i:=1 to 8 do
   dec(koc.bod[i][3],10);
}
  inc(phix,uhx);inc(phiy,uhy);inc(phiz,uhz);
  delay(10);
  setcol(0);
  for n:=1 to 8 do
   begin
   end;

 until keypressed;
end;

begin
 InitAnim;
 Kresli;
end.
