Program TriDpohyb;
uses Crt,
     Graph,
     SchGraph;

Type Bodtype=record
              x,y,z:integer;
             end;
Type CubeType=record
               bod:array[1..8,1..3] of longint;
               cia:array[1..12,1..2] of byte;
               plo:array[1..6,1..4] of byte;
              end;
Type PyramType=record
                bod:array[1..4,1..3] of longint;
                cia:array[1..6,1..2] of byte;
                plo:array[1..4,1..3] of byte;
               end;

var
 ctab:array[0..255] of integer;
 stab:array[0..255] of integer;
 koc:cubetype;
 pyr:pyramtype;
 xp,yp,z:array[1..8] of integer;
 req:string[6];

function cosinus(i:byte):integer; begin cosinus:=ctab[i]; end;
function sinus(i:byte):integer; begin sinus:=stab[i]; end;

Procedure InitAnim;
var i:integer;
begin
 InitGr;
 setcolor(15);
 rectangle(0,20,639,479);
 rectangle(0,0,639,479);
 settextjustify(centertext,centertext);
 outtextxy(320,10,'(C) MArtin Schmidt, Semestralna Praca: 3D KOCKA');
 for i:=0 to 255 do ctab[i]:=round(-cos(i*pi/128)*divd);
 for i:=0 to 255 do stab[i]:=round(sin(i*pi/128)*divd);

 koc.bod[1][1]:=-30; koc.bod[1][2]:=-30; koc.bod[1][3]:=-30;
 koc.bod[2][1]:=30; koc.bod[2][2]:=-30; koc.bod[2][3]:=-30;
 koc.bod[3][1]:=30; koc.bod[3][2]:=30; koc.bod[3][3]:=-30;
 koc.bod[4][1]:=-30; koc.bod[4][2]:=30; koc.bod[4][3]:=-30;
 koc.bod[5][1]:=-30; koc.bod[5][2]:=-30; koc.bod[5][3]:=30;
 koc.bod[6][1]:=30; koc.bod[6][2]:=-30; koc.bod[6][3]:=30;
 koc.bod[7][1]:=30; koc.bod[7][2]:=30; koc.bod[7][3]:=30;
 koc.bod[8][1]:=-30; koc.bod[8][2]:=30; koc.bod[8][3]:=30;

 koc.cia[1][1]:=1;koc.cia[1][2]:=2;
 koc.cia[2][1]:=2;koc.cia[2][2]:=3;
 koc.cia[3][1]:=3;koc.cia[3][2]:=4;
 koc.cia[4][1]:=4;koc.cia[4][2]:=1;
 koc.cia[5][1]:=5;koc.cia[5][2]:=6;
 koc.cia[6][1]:=6;koc.cia[6][2]:=7;
 koc.cia[7][1]:=7;koc.cia[7][2]:=8;
 koc.cia[8][1]:=8;koc.cia[8][2]:=5;
 koc.cia[9][1]:=1;koc.cia[9][2]:=5;
 koc.cia[10][1]:=2;koc.cia[10][2]:=6;
 koc.cia[11][1]:=3;koc.cia[11][2]:=7;
 koc.cia[12][1]:=4;koc.cia[12][2]:=8;

 koc.plo[1][1]:=1;koc.plo[1][2]:=2;koc.plo[1][3]:=3;koc.plo[1][4]:=4;
 koc.plo[2][1]:=5;koc.plo[2][2]:=6;koc.plo[2][3]:=7;koc.plo[2][4]:=8;
 koc.plo[3][1]:=1;koc.plo[3][2]:=5;koc.plo[3][3]:=6;koc.plo[3][4]:=2;
 koc.plo[4][1]:=2;koc.plo[4][2]:=6;koc.plo[4][3]:=7;koc.plo[4][4]:=3;
 koc.plo[5][1]:=4;koc.plo[5][2]:=8;koc.plo[5][3]:=7;koc.plo[5][4]:=3;
 koc.plo[6][1]:=1;koc.plo[6][2]:=5;koc.plo[6][3]:=8;koc.plo[6][4]:=4;

end;

{  QuickSort  }
{procedure QuickSort(L,R:integer);
var I,J:integer;
    M,T:longint;
begin
  I:=L; J:=R; M:=koc.cia[(L+R) shr 1];
  repeat
    while Data[I]<M do Inc(I);
    while M<Data[J] do Dec(J);
    if I<=J then begin
      T:=Data[I]; Data[I]:=Data[J]; Data[J]:=T;
      Inc(I); Dec(J);
    end;
  until I>J;
  if L<J then QuickSort(L,J);
  if I<R then QuickSort(I,R);
end;
}
Procedure DrawCube(x,y:integer;f:byte);
var i:integer;
begin
 setcol(f);
 x:=x-320;
 y:=y-240;
 for i:=1 to 12 do
 linem(x+xp[koc.cia[i][1]],y+yp[koc.cia[i][1]],
       x+xp[koc.cia[i][2]],y+yp[koc.cia[i][2]]);
end;

Procedure FillCube(x,y:integer);
var i:integer;
    pt:array[1..4] of pointtype;
begin
 x:=x-320;
 y:=y-240;
{ for i:=1 to 6 do
  begin
   setcolor(i);
   drawpoly
  end;}
end;

Procedure Kresli;
var n,i,j,k,x,y,zz:longint;
    phix,phiy,phiz:byte;
    uhx,uhy,uhz,pzz:integer;
begin
 uhx:=1;
 uhy:=1;
 uhz:=1;
 phix:=0;phiy:=0;phiz:=0;
 pzz:=0;
 zz:=0;
{  for i:=1 to 8 do
   inc(koc.bod[i][3],30);}

 repeat
   if (zz=100)or(zz=-60) then pzz:=pzz*(-1);
   inc(zz,pzz);
   for n:=1 to 8 do begin
     i:=(cosinus(phiy)*koc.bod[n,1]-sinus(phiy)*koc.bod[n,3]) div divd;
     j:=(cosinus(phiz)*koc.bod[n,2]-sinus(phiz)*i) div divd;
     k:=(cosinus(phiy)*koc.bod[n,3]+sinus(phiy)*koc.bod[n,1]) div divd;
     x:=(cosinus(phiz)*i+sinus(phiz)*koc.bod[n,2]) div divd;
     y:=(cosinus(phix)*j+sinus(phix)*k) div divd;
     z[n]:=(cosinus(phix)*k-sinus(phix)*j) div divd;
     dec(z[n],zz);
{     dec(x,80);}
     xp[n]:=320+(-x*dist) div (z[n]-dist);
     yp[n]:=240+(-y*dist) div (z[n]-dist);
   end;
  drawcube(100,100,15);
  drawcube(500,100,14);
  drawcube(100,300,13);
  drawcube(500,300,12);
  drawcube(300,200,11);
  inc(phix,uhx);inc(phiy,uhy);inc(phiz,uhz);
  delay(100);
  drawcube(100,100,0);
  drawcube(500,100,0);
  drawcube(100,300,0);
  drawcube(500,300,0);
  drawcube(300,200,0);
 until keypressed;
end;

begin
 InitAnim;
 Kresli;
end.
