unit buttons2;

interface

uses graph,crt,moused;
Const  MaxTl          = 30;
       MaxPl          = 20;
       MaxList        = 20;
       Snd:boolean    = true;                       { Zap/Vyp Zvuku }

type TlType=record
          x,y,d,v,f,ft:integer;
          tx:string[40];
          shad,activ,inv:boolean;
         end;
type PlType=record
             x,y,d,v,f:word;
             inv:boolean;
            end;

Type ListaType=record
                ptl:byte;                         {Pocet tlacitok }
                tl:array[1..Maxtl] of pointer;    {Tlacitka       }
                pl:Pltype;                        {Plocha-Podklad }
                mspl:pointer;
                activ,                            {Ci je aktivna tato lista }
                activpl:boolean;                  {Ci ma nejaku plochu }
                pk:array[1..maxlist] of byte;     {S ktorymi listami sa prekryva }
                ppr:byte;                         {S kolkymi listami ma prienik }
               end;

var sedit:string;
    PocList:byte;
    Llp:array[1..maxlist] of byte;
    Listap:array[1..maxlist] of pointer;
    Lista:Listatype;
    Tlac:TlType;
    Ktl,Ktt:byte;
    Pole:array[1..maxlist] of byte;
    Data:array[1..10] of string[10];

Procedure Mybar(x,y,d,v:word;Fil,Col:byte);
Procedure MyLine(x,y,x1,y1:word;typ,col:byte);
Procedure Beep(so,de:word);
Procedure Button(x,y,d,v,f,ft:integer;txt:string;shi,shtx,br:boolean);
Procedure Click(x,y,d,v,f,ft:integer;txt:string;shtx:boolean);
Procedure Screen;
Procedure Wrt(x,y,f:integer;txt:string;sht:boolean);
Procedure Print(x,y,f:integer;txt:string;sht:boolean);
Function  Key:word;
Function  EditMenu(x,y,d,v,f,ft,fpt:integer;txt,hod:string;maxd:byte):string;
Function  Edituj(x,y:word;maxd,col,cob:byte;zact:string):string;
Procedure Message(x,y,f,ft,ftl,ftlt:integer;txt:string);
Procedure Errorbox(txt:string);
Function  AnoNie(x,y,f,fan,ft,ftan:integer;txt:string):boolean;
Procedure InitButt(kl,kt,xt,yt,dt,vt,ftl,ftt:integer;txt:string;shtxt,act,invt:boolean);
Procedure PlaceButt(kl,kt:byte);
Procedure DeleteButton(kl,kt:byte);
Procedure KtoreTl(mx,my:integer);
Function  Tlacitka(x,y:word;poct,ftl,ftx,dt:byte):byte;

Procedure InitLista(potl:byte;px,py,pd,pv,pf:integer;pinv:boolean);
Procedure PlaceLista(kl:byte;x,y:integer;obnov:boolean);
Procedure CloseLista(kl:byte);
Function  KtoraLista(mlx,mly:integer):byte;
Procedure ChangeButt(kl,kt:byte;txt:string);
Procedure ChangeButtF(kl,kt:byte;f,ft:byte);
Procedure ZistiPrienik(kl:byte);
Procedure ZistiVsetkyPrieniky;

implementation

Const kurzblik = 1000;

Procedure Mybar(x,y,d,v:word;fil,Col:byte);
begin
 hid;
 setfillstyle(fil,col);
 bar(x,y,x+d,y+v);
 sho;
end;

Procedure MyLine(x,y,x1,y1:word;typ,col:byte);
var ls,lh:byte;
begin
 hid;
 ls:=typ;
 if ls>3 then begin ls:=ls-4;lh:=3;end
         else lh:=1;
 Setlinestyle(ls,0,lh);
 Setcolor(col);
 Line(x,y,x1,y1);
 SetlineStyle(0,0,1);
 sho;
end;

Procedure Beep(so,de:word);
begin
 if snd then
 begin
  sound(so);
  delay(de);
  nosound;
 end;
end;

(*** Vytvori tlacidlo: x,y,dlzka,vyska,farba,f.textu,text ***
*** shi:inverzne tlac.,shtx:shadow textu,br:bar;         ***)
Procedure Button(x,y,d,v,f,ft:integer;txt:string;shi,shtx,br:boolean);
var fh,fd:word;
begin
 if f<8 then begin fh:=f+8;fd:=8;end;
 if f>7 then begin fh:=15;fd:=f-8;end;
 if shi then
  begin
   if f<8 then begin fh:=8;fd:=f+8;end;
   if f>7 then begin fh:=f-8;fd:=15;end;
  end;
 setcolor(fh);
 rectangle(x,y,x+d,y+v);
 rectangle(x+1,y+1,x+d-1,y+v-1);
 setfillstyle(1,f);
 if not br then setfillstyle(1,0);
 bar(x+2,y+2,x+d-2,y+v-2);
 setcolor(fd);
 line(x+1,y+v-1,x+d,y+v-1);
 line(x,y+v,x+d,y+v);
 line(x+d-1,y+1,x+d-1,y+v);
 line(x+d,y,x+d,y+v);
 setcolor(0);
 settextjustify(1,1);
 if shtx then outtextxy(x+round(d/2)+1,y+round(v/2)+1,txt);
 setcolor(ft);
 outtextxy(x+round(d/2),y+round(v/2),txt);
 settextjustify(0,1);
end;
{
*** Klikne s tlacidlom: x,y,d,v,f,ft,txt   ***
}
Procedure Click(x,y,d,v,f,ft:integer;txt:string;shtx:boolean);
begin
 hid;
 button(x,y,d,v,f,ft,'',true,true,true);
 setcolor(0);
 settextjustify(1,1);
 if shtx then outtextxy(x+round(d/2)+2,y+round(v/2)+2,txt);
 setcolor(ft);
 outtextxy(x+round(d/2)+1,y+round(v/2)+1,txt);
 beep(1000,2);
 delay(200);
 button(x,y,d,v,f,ft,txt,false,shtx,true);
 sho;
end;

Procedure screen;
begin
 button(0,0,639,479,7,0,'',false,true,true);
 button(10,30,619,435,7,0,'',true,true,false);
 setcolor(0);
 outtextxy(410,472,'By Martin Schmidt  MSCH.(R)');
end;

Procedure Wrt(x,y,f:integer;txt:string;sht:boolean);
begin
 setcolor(0);
 settextjustify(1,1);
 if sht then outtextxy(x+1,y+1,txt);
 setcolor(f);
 outtextxy(x,y,txt);
 settextjustify(0,1);
end;

Procedure Print(x,y,f:integer;txt:string;sht:boolean);
begin
 setcolor(0);
 if sht then outtextxy(x+1,y+1,txt);
 setcolor(f);
 outtextxy(x,y,txt);
end;

Function Key:word;
var k:char;
    b,b1:byte;
    w:word;
begin                           {1C0D - Enter}
 k:=readkey;
 b:=ord(k);
 if k=#0 then k:=readkey;
 b1:=ord(k);
 asm
  xor ax,ax
  mov ah,b
  mov al,b1
  mov w,ax
 end;
 key:=w;
end;

Function Edituj(x,y:word;maxd,col,cob:byte;zact:string):string;
var qe,boo:boolean;
    hod:string;
    kk,pk,ci:word;
    fk:byte;
    poc:longint;
begin
 qe:=false;
 hod:=zact;
 fk:=col;poc:=0;
 pk:=length(hod);
 mybar(x,y-4,(maxd+1)*8,8,1,cob);
 print(x,y,col,hod,true);
 boo:=true;
 repeat
  inc(poc);
  if poc>kurzblik then fk:=cob;
  if poc>2*kurzblik then begin fk:=col;poc:=0;end;
{  mybar(x+pk*9,y+8,9,1,fk,1);}
  print(x+pk*8,y,fk,'_',false);
  if keypressed then
   begin
    kk:=key;
    if not(hi(kk)in[$00,$08,$0D,$1B]) then
     begin
      if boo then begin hod:='';pk:=0;end;
      if length(hod)<maxd then begin insert(chr(hi(kk)),hod,pk+1);inc(pk);end
                          else beep(1000,4);
     end;
    if kk=$0D0D then                    { ENTER }
      qe:=true;
    if kk=$004B then                    { Left }
     if pk>0 then dec(pk);
    if kk=$004D then                    { Right }
     if pk<Length(hod) then inc(pk);
    if kk=$0053 then                    { Del }
     if (length(hod)=0)or(pk>length(hod))
      then beep(1000,4) else delete(hod,pk+1,1);
    if kk=$0808 then                    { BckSPC }
     if pk>0 then begin delete(hod,pk,1);dec(pk);end
                  else beep(1000,5);

    mybar(x,y-4,(maxd+1)*8,8,1,cob);
    print(x,y,col,hod,true);
    boo:=false;
    if kk=$1B1B then                    { ESC }
     begin
      qe:=true;
      hod:='esc';
     end;
   end;
 until qe;
 edituj:=hod;
end;

Function EditMenu(x,y,d,v,f,ft,fpt:integer;txt,hod:string;maxd:byte):string;
var kk:char;
    xt,yt,ii:integer;
    po:pointer;
    bool,shtx:boolean;
begin
 shtx:=true;
 hid;
 getmem(po,imagesize(x,y,x+d,y+v));
 getimage(x,y,x+d,y+d,po^);
 button(x,y,d,v,f,ft,'',false,shtx,true);
 wrt(x+trunc(d/2),y+trunc(v/4),ft,txt,shtx);
 button(x+10,y+(2*trunc(v/3))-10,d-20,20,f,ft,'',true,shtx,true);
 sedit:='';xt:=x+20;yt:=y+(2*trunc(v/3));
 sedit:=edituj(xt,yt,maxd,fpt,f,hod);
 putimage(x,y,po^,normalput);
 freemem(po,imagesize(x,y,x+d,y+v));
 if kk=#27 then sedit:='esc';
 editmenu:=sedit;
 sho;
end;

Procedure Message(x,y,f,ft,ftl,ftlt:integer;txt:string);
var kk:char;
    dm:integer;
    po:pointer;
    qm:boolean;
begin
 hid;
 dm:=length(txt)*9;
 getmem(po,imagesize(0,0,dm+20,70));
 getimage(x,y,x+dm+20,y+70,po^);
 button(x,y,dm+20,70,f,ft,'',false,true,true);
 wrt(x+trunc((dm+20)/2),y+trunc(70/4),ft,txt,true);
 button(x+10,y+(2*trunc(70/3))-10,dm,20,ftl,ftlt,'OK',false,true,true);
 sho;qm:=false;
 repeat
  if leftbutton then
   if (mousex>x+10)and(mousex<x+dm)and
      (mousey>y+(2*trunc(70/3))-10)and(mousey<y+(2*trunc(70/3))+10)then
    begin
     click(x+10,y+(2*trunc(70/3))-10,dm,20,ftl,ftlt,'OK',true);
     qm:=true;
    end;
  if keypressed then
   begin
    kk:=readkey;
    if kk=#13 then
     begin
      qm:=true;
      click(x+10,y+(2*trunc(70/3))-10,dm,20,ftl,ftlt,'OK',true);
     end;
   end;
 until qm;
 hid;
 putimage(x,y,po^,normalput);
 freemem(po,imagesize(0,0,dm+20,70));
 sho;
end;

Procedure errorbox(txt:string);
begin
 message(310-(length(txt)*10)div 2,200,4,15,4,14,txt);
end;

Function AnoNie(x,y,f,fan,ft,ftan:integer;txt:string):boolean;
var qq,k:boolean;
    kk:char;
    po:pointer;
begin
 hid;
 getmem(po,imagesize(0,0,105,60));
 getimage(x,y,x+105,y+60,po^);
 button(x,y,105,60,f,ft,'',false,true,true);
 wrt(x+52,y+15,ft,txt,true);
 button(x+10,y+30,40,20,fan,ftan,'ANO',false,true,true);
 button(x+55,y+30,40,20,fan,ftan,'NIE',false,true,true);
 qq:=false;k:=false;sho;
 kk:='0';
 repeat
  if keypressed then begin kk:=readkey;k:=true;end;
  if leftbutton or k then
   begin
    if ((mousex>x+10)and(mousex<x+50)and
       (mousey>y+30)and(mousey<y+50)) or
       ((kk='a')or(kk='A')or(kk=#13)) then
     begin
      click(x+10,y+30,40,20,fan,ftan,'ANO',true);
      anonie:=true;qq:=true;
     end;
    if ((mousex>x+55)and(mousex<x+95)and
       (mousey>y+30)and(mousey<y+50))or
       ((kk='n')or(kk='N'))then
     begin
      click(x+55,y+30,40,20,fan,ftan,'NIE',true);
      anonie:=false;qq:=true;
     end;
    if kk=#27 then begin qq:=true;anonie:=false;end;
   end;
 until qq;
 delay(100);
 hid;
 putimage(x,y,po^,normalput);
 freemem(po,imagesize(0,0,105,60));
 sho;
end;

Function SArea(x,y,d,v,x1,y1:integer):boolean;
begin
 if (x1>x)and(x1<x+d)and(y1>y)and(y1<y+v)then Sarea:=true
                                         else Sarea:=false;
end;

Function Tlacitka(x,y:word;poct,ftl,ftx,dt:byte):byte;
var po:pointer;
    i,mx,my:integer;
    qt:boolean;
begin
 hid;
 getmem(po,imagesize(0,0,dt+10,25*poct+5));
 getimage(x,y,x+dt+10,y+5+25*poct,po^);
 button(x,y,dt+10,25*poct+5,ftl,ftx,'',false,true,true);
 for i:=1 to poct do
  Button(x+5,y+(i-1)*25+5,dt,20,ftl,ftx,data[i],false,true,true);
 qt:=false;sho;
 repeat
  if leftbutton then
   begin
    mx:=mousex;my:=mousey;
    repeat until not leftbutton;
    for i:=1 to poct do
     if sarea(x+5,y+(i-1)*25+5,dt,20,mx,my) then
      begin
       click(x+5,y+(i-1)*25+5,dt,20,ftl,ftx,data[i],true);
       delay(50);
       tlacitka:=i;
       qt:=true;
      end;
   end;
  if rightbutton then
   begin
    repeat until not rightbutton;
    tlacitka:=0;
    qt:=true;
    beep(500,10);
   end;
 until qt;
 hid;
 putimage(x,y,po^,normalput);
 freemem(po,imagesize(0,0,dt+10,25*poct+5));
 sho;
end;


Function PrienikCiar(x1,y1,x2,y2:integer):boolean;
var v1,v2:integer;
begin

end;

Function PrienikList(li1,li2:byte):boolean;
var l1,l2:pltype;
    bool:boolean;
    i:integer;
begin
 move(listap[li1]^,lista,sizeof(lista));
 l1:=lista.pl;
 move(listap[li2]^,lista,sizeof(lista));
 l2:=lista.pl;
 bool:=false;
 Prieniklist:=false;
 if sarea(l1.x,l1.y,l1.d,l1.v,l2.x,l2.y) then bool:=true;
 if sarea(l1.x,l1.y,l1.d,l1.v,l2.x+l2.d,l2.y) then bool:=true;
 if sarea(l1.x,l1.y,l1.d,l1.v,l2.x,l2.y+l2.v) then bool:=true;
 if sarea(l1.x,l1.y,l1.d,l1.v,l2.x+l2.d,l2.y+l2.v) then bool:=true;
 if sarea(l2.x,l2.y,l2.d,l2.v,l1.x,l1.y) then bool:=true;
 if sarea(l2.x,l2.y,l2.d,l2.v,l1.x+l1.d,l1.y) then bool:=true;
 if sarea(l2.x,l2.y,l2.d,l2.v,l1.x,l1.y+l1.v) then bool:=true;
 if sarea(l2.x,l2.y,l2.d,l2.v,l1.x+l1.d,l1.y+l1.v) then bool:=true;
 if bool then Prieniklist:=true;
 if bool then exit;
 if (l1.y>l2.y)and(l1.y<l2.y+l2.v)and(l1.x<l2.x)and(l1.x+l1.d>l2.x)then bool:=true;
 if (l1.y+l1.v>l2.y)and(l1.y+l1.v<l2.y+l2.v)and(l1.x<l2.x)and(l1.x+l1.d>l2.x)then bool:=true;
 if (l1.y<l2.y)and(l1.y+l1.v>l2.y+l2.v)and(l1.x>l2.x)and(l1.x<l2.x+l2.d)then bool:=true;
 if bool then Prieniklist:=true;
end;

Procedure InitLista(potl:byte;px,py,pd,pv,pf:integer;pinv:boolean);
var ktlista:byte;
begin
 inc(poclist);
 ktlista:=poclist;
 llp[ktlista]:=ktlista;
 getmem(listap[ktlista],sizeof(lista));
 lista.ptl:=potl;
 lista.activ:=false;
 if pf=0 then lista.activpl:=false else lista.activpl:=true;
 lista.pl.x:=px;
 lista.pl.y:=py;
 lista.pl.d:=pd;
 lista.pl.v:=pv;
 lista.pl.f:=pf;
 lista.pl.inv:=pinv;
 move(lista,listap[ktlista]^,sizeof(lista));
end;

Procedure Initbutt(kl,kt,xt,yt,dt,vt,ftl,ftt:integer;txt:string;shtxt,act,invt:boolean);
begin
 move(listap[kl]^,lista,sizeof(lista));
 if kt>lista.ptl then exit;
 getmem(lista.tl[kt],sizeof(tlac));
 move(lista.tl[kt]^,tlac,sizeof(tlac));
  tlac.x:=xt;
  tlac.y:=yt;
  tlac.d:=dt;
  tlac.v:=vt;
  tlac.f:=ftl;
  tlac.ft:=ftt;
  tlac.tx:=txt;
  tlac.activ:=act;
  tlac.shad:=shtxt;
  tlac.inv:=invt;
 move(tlac,lista.tl[kt]^,sizeof(tlac));
 move(lista,listap[kl]^,sizeof(lista));
end;

Procedure DeleteButton(kl,kt:byte);
var i:integer;
begin
 move(listap[kl]^,lista,sizeof(lista));
 if kt>lista.ptl then exit;
 if kt<lista.ptl then
  begin
   dec(lista.ptl);
   for i:=kt to lista.ptl do
    begin
     freemem(lista.tl[i],sizeof(tlac));
     getmem(lista.tl[i],sizeof(tlac));
     move(lista.tl[i+1]^,lista.tl[i]^,sizeof(tlac));
    end;
   freemem(lista.tl[i+1],sizeof(tlac));
  end else
  begin
   freemem(lista.tl[lista.ptl],sizeof(tlac));
   dec(lista.ptl);
  end;
 move(lista,listap[kl]^,sizeof(lista));
end;

Procedure PlaceButt(kl,kt:byte);
begin
 move(listap[kl]^,lista,sizeof(lista));
 move(lista.tl[kt]^,tlac,sizeof(tlac));
 with tlac do
 begin
  hid;
  button(lista.pl.x+x,lista.pl.y+y,d,v,f,ft,tx,inv,shad,true);
  sho;
 end;
end;

Procedure ChangeButt(kl,kt:byte;txt:string);
begin
 move(listap[kl]^,lista,sizeof(lista));
 move(lista.tl[kt]^,tlac,sizeof(tlac));
 tlac.tx:=txt;
 move(tlac,lista.tl[kt]^,sizeof(tlac));
end;

Procedure ChangeButtF(kl,kt:byte;f,ft:byte);
begin
 move(listap[kl]^,lista,sizeof(lista));
 move(lista.tl[kt]^,tlac,sizeof(tlac));
 tlac.f:=f;
 tlac.ft:=ft;
 move(tlac,lista.tl[kt]^,sizeof(tlac));
end;

Procedure DajNavrch(kl:byte);
var i,k:integer;
begin
 k:=1;
 for i:=1 to poclist do if llp[i]=kl then k:=i;
 for i:=k downto 2 do llp[i]:=llp[i-1];
 llp[1]:=kl;
end;

Function AktivL(kl:byte):boolean;
var listazal:listatype;
begin
 move(listap[kl]^,listazal,sizeof(listazal));
 AktivL:=listazal.activ;
end;

Function PriorL(kl:byte):byte;
var i:byte;
begin
 PriorL:=0;
 for i:=1 to poclist do
  if llp[i]=kl then PriorL:=i;
end;

Procedure BubbleSort(n:integer);
var I,J:integer;
    T:longint;
begin
  for I:=1 to N-1 do begin
    J:=I;
    while (J>0) and (priorl(pole[J])>priorl(pole[J+1])) do begin
      T:=pole[J]; pole[J]:=pole[J+1]; pole[J+1]:=T;
      Dec(J);
    end;
  end;
end;

Procedure ZistiPrienik(kl:byte);
var i,j:integer;
    z:array[1..maxlist] of byte;
begin
 j:=0;
 for i:=1 to poclist do
  begin
   if i<>kl then
    if prieniklist(kl,i) then
     begin
      inc(j);
      z[j]:=i;
     end;
  end;
 move(listap[kl]^,lista,sizeof(lista));
 lista.ppr:=j;
 for i:=1 to j do lista.pk[i]:=z[i];
 move(lista,listap[kl]^,sizeof(lista));
end;

Procedure ZistiVsetkyPrieniky;
var i:integer;
begin
 for i:=1 to poclist do zistiprienik(i);
end;


Procedure PlaceLista(kl:byte;x,y:integer;obnov:boolean);
var i:integer;
begin
 move(listap[kl]^,lista,sizeof(lista));
 if lista.activ then exit;
 Dajnavrch(kl);
 hid;
 with lista do
 begin
  if obnov=false then begin pl.x:=x;pl.y:=y;end;
  activ:=true;
  if activpl then
   begin
    getmem(mspl,pl.d*pl.v);
    getimage(pl.x,pl.y,pl.x+pl.d,pl.y+pl.v,mspl^);
    button(pl.x,pl.y,pl.d,pl.v,pl.f,0,'',pl.inv,true,true);
   end;
  move(lista,listap[kl]^,sizeof(lista));
  for i:=1 to ptl do Placebutt(kl,i);
 end;
 sho;
end;

Procedure CloseLista(kl:byte);
begin
 hid;
 move(listap[kl]^,lista,sizeof(lista));
 with lista do
 begin
  activ:=false;
  Putimage(pl.x,pl.y,mspl^,normalput);
  Freemem(mspl,pl.d*pl.v);
 end;
 move(lista,listap[kl]^,sizeof(lista));
 sho;
end;

Function KtoraLista(mlx,mly:integer):byte;
var i,ii,iii,j,k,hl:integer;
    bool:boolean;
    zz:array[1..maxlist] of byte;
    lista1:listatype;
begin
 k:=0;i:=0;
 repeat
  inc(i);
  move(listap[llp[i]]^,lista,sizeof(lista));
  with lista do
   if lista.activ then
    begin
     if (mlx>pl.x)and(mlx<pl.x+pl.d)
     and(mly>pl.y)and(mly<pl.y+pl.v) then k:=llp[i];
    end;
 until (k>0)or(i=poclist);
 if (k>0)and(priorl(k)>1) then
 begin
  move(listap[k]^,lista,sizeof(lista));
  if (lista.ppr>0) then
   begin
    j:=0;
    for i:=1 to lista.ppr do
     if priorl(lista.pk[i])<priorl(k) then
      if aktivl(lista.pk[i])then
       begin inc(j);zz[j]:=lista.pk[i];end;
    hl:=j;
    if hl>0 then
    for i:=1 to hl do
     begin
      move(listap[zz[i]]^,lista1,sizeof(lista1));
      for ii:=1 to lista1.ppr do
       begin
        bool:=false;
        for iii:=1 to j do if zz[iii]=lista1.pk[ii] then bool:=true;
        if priorl(lista1.pk[ii])>priorl(zz[i]) then bool:=true;
        if (lista1.pk[ii]<>k)and(bool=false)and(aktivl(lista1.pk[ii])) then
         begin inc(j);zz[j]:=lista1.pk[ii];end;
       end;
     end;
    if j>0 then
     begin
      for i:=1 to j do pole[i]:=zz[i];
      BubbleSort(j);
      for i:=1 to j do Closelista(pole[i]);
      Closelista(k);
      for i:=j downto 1 do Placelista(pole[i],0,0,true);
      Placelista(k,0,0,true);
      k:=k+100;
     end;
   end;
{  if hl>1 then
  begin
   bool:=false;
   if hl>1 then for i:=1 to hl-1 do
    begin
     if prieniklist(llp[i],k) then begin closelista(llp[i]);bool:=true;end;
    end;
   if bool then closelista(k);
   if hl>1 then for i:=1 to hl-1 do
    begin
     if prieniklist(llp[hl-1],k) then Placelista(llp[hl-1],0,0,true)
                                 else Dajnavrch(llp[hl-1]);
    end;
   if bool then Placelista(k,0,0,true);
   dajnavrch(k);
   if bool then k:=0;
  end;}
 end;
 Ktoralista:=k;
end;

Procedure KtoreTl(mx,my:integer);
var i,k:word;
begin
 k:=0;ktt:=0;ktl:=0;
 i:=ktoralista(mx,my);
 ktl:=i;
 if (i>0)and(i<100) then
 begin
  move(listap[i]^,lista,sizeof(lista));
  with lista do
  begin
   for i:=1 to ptl do
    begin
     move(tl[i]^,tlac,sizeof(tlac));
     if Sarea(pl.x+tlac.x,pl.y+tlac.y,tlac.d,tlac.v,mx,my) then k:=i;
    end;
  if k>0 then
   begin
    hid;
    move(tl[k]^,tlac,sizeof(tlac));
    if not tlac.inv then
    click(pl.x+tlac.x,pl.y+tlac.y,tlac.d,tlac.v,tlac.f,tlac.ft,tlac.tx,true);
    sho;
   end;
  end;
 end;
 if ktl>100 then ktl:=ktl-100;
 ktt:=k;
end;

end.